// 函数mystrchr(const char* src, int ch)的验证
//要点：
    //1.函数执行前src的内容构成长度为n的物理字符串。
    //2.查找字符ch在src所指字符串中首次出现的位置。
//关键字：字符串、内置谓词、逻辑变量

#include <limits.h>
////////////////////////////////////////////逻辑变量////////////////////////////////////////////////

//@ logic int n, oldch;     // n和oldch分别记录物理字符串src的长度和要查找的字符ch 
//@ logic char *oldsrc;     // oldsrc记录物理字符串src的起始地址

/////////////////////////////////////////strchr函数的验证///////////////////////////////////////////
//函数协议：
//前条件：描述函数入口处的字符串以及待查找字符的性质
//后条件：函数返回值等于NULL（0），则src所指字符串中不存在字符ch；
//        不等于NULL，则src所指字符串中存在字符ch，且返回值指向字符串src中第一次出现字符ch的位置。   
/*@ 
  requires 
      \is_pstring(src, n) && 0 <= ch <= 255 && oldch == ch && oldsrc == src && n < INT_MAX
      ;
  ensures
      \is_pstring(oldsrc, n) && \result == \null && !\membership(\string(oldsrc, n), oldch)
    ||
      \is_pstring(oldsrc, n) && 0 <= \offset(\result)-\offset(oldsrc) < n 
      && *(\result) ==  oldch
      && \result == oldsrc + \offset(\result) - \offset(oldsrc) 
      // 需要这个断言，表明\result和oldsrc指向同一个数据块
      && !\membership(\prefix(\string(oldsrc, n), \offset(\result) - \offset(oldsrc)), oldch)
      ;
*/
char* mystrchr(const char* src, int ch) {
    int m;
    m = 0;
    /*@ loop invariant
          \is_pstring(oldsrc, n) && 0 <= m <= n 
          && n < INT_MAX && src == oldsrc + m 
          && 0 <= ch <= 255 && oldch == ch
          && !\membership(\prefix(\string(oldsrc,n), \offset(oldsrc+m) - \offset(oldsrc)), ch)
        ;
    */
    while(*src != 0){
        if(*src == ch) {
            return (char *)src;
        }
        src = src+1;
        m = m+1;
    }
    return 0;
}